var debug = false;
$(document).ready(function() {
    if(location.protocol === 'file:'){
        let file_url = $("img").attr("src");
        toDataURL(file_url, function (data, contenttype) {
            let blob = new Blob([data]);
            let fileReader = new FileReader();
            fileReader.onloadend = function(e) {
                let arr = new Uint8Array(e.target.result);
                let header = '';
                for (let i = 0; i < arr.length; i++) {
                    header += arr[i].toString(16);
                }
                checkMimeHeader(header, function (type, ext, header, cont){
                    let options = browser.storage.sync.get(['file_types','labels','censor_type','bar_configuration','blur_configuration','pixel_configuration','gif_configuration']);
                    options.then((res) => {
                        if (!processableContentType('image/'+type, res.file_types, null)) {
                            return;
                        }
                        $("img").css('filter','blur(50px)');
                        let imageData = new Image();
                        imageData.onload = function () {
                            let tempCanvas = document.createElement('canvas');
                            tempCanvas.width = this.naturalWidth;
                            tempCanvas.height = this.naturalHeight;
                            let tempCtx = tempCanvas.getContext('2d');
                            tempCtx.drawImage(imageData, 0, 0, tempCanvas.width, tempCanvas.height);
                            let frame = tempCtx.getImageData(0, 0, tempCanvas.width, tempCanvas.height);
                            let sending = browser.runtime.sendMessage({
                                frame: frame,
                                width: tempCanvas.width,
                                height: tempCanvas.height
                            });
                            sending.then(response => {
                                let valid_detections = response.valid_detections;
                                let classes = response.classes;
                                let scores = response.scores;
                                let boxes = response.boxes;
                                let marvinImage = new MarvinImage();
                                marvinImage.load(file_url, function () {
                                    paintCensor(marvinImage, res.censor_type, res.labels, valid_detections, classes, scores, boxes,
                                        res.bar_configuration,
                                        res.pixel_configuration,
                                        res.blur_configuration
                                    );
                                    let marvinBlob = marvinImage.toBlob();
                                    let censored_url = URL.createObjectURL(marvinBlob);
                                    $("img").attr("src",censored_url);
                                    $("img").css('filter','');
                                });
                            });
                        }
                        imageData.src = file_url;
                    });
                });
            };
            fileReader.readAsArrayBuffer(blob.slice(0, 4))
        });
    }
})

